#ifndef MGAPP_HELP_H
#define MGAPP_HELP_H

#include <dlfcn.h>

/* module functions(system level) */
void* module_open(char *filename, unsigned int flags);
void* module_symbol(void *handle, char *sym_name);
void module_close(void *handle);

/* string functions */
char* strchomp(char *string);
char* strjoin(char *list, char *entry);
char** strsplit(char *string, const char *del);
char* strconcat(char *first, char *second);
void strfreev(char **strings);
char **create_cmdline_args(char *string, int *argc);

void mfree(void *data);

typedef int (*DListCompareFunc)(void *d1, void *d2);

/* a list of data... */
typedef struct _DList DList;
struct _DList
{
  void *data;
  DList *next;
  DList *prev;
};


DList* dlist_last_node(DList *list);
DList* dlist_find(DList *list, void *data);
DList* dlist_find_custom(DList *list, void *data, DListCompareFunc func);
DList* dlist_prepend(DList *list, void *data);
DList* dlist_append(DList *list, void *data);
DList* dlist_delete_node(DList *list, DList *node);
DList* dlist_next(DList *dlist);

#endif  /* MGAPP_HELP_H */
