/*
 * FILE NAME au1000_fpga.h
 *
 * BRIEF MODULE DESCRIPTION
 *	Test driver
 *
 *  Author: Padraig  O'Mathuna <padraigo@yahoo.com>
 *
 * Copyright 2002 Padraig O'Mathuna.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __FPGA_H__
#define __FPGA_H__

#include <linux/ioctl.h>

/*
 * S set thru pointer
 * G get thru pointer
 * T tell thru arg
 * Q query thru arg
 * X G & S atomically
 * H T & Q atomically 
 */
#define FPGA_IOC_MAGIC     'f'
#define FPGA_IOTRESET       _IOW(FPGA_IOC_MAGIC,1,int) // issue an FPGA reset
#define FPGA_IOQDONE        _IOR(FPGA_IOC_MAGIC,2,int) // read done status

#define FPGA_IOC_MAXNR     2
#define FPGA_PROCDIR        "driver/fpga"

#endif // __AU1000_FPGA_H__








