#ifndef MGAPP_MAIN_H
#define MGAPP_MAIN_H

#include <pthread.h>
#include "mgapp.h"
#include "libmgapp.h"

/* XXX names and paths */
#define MGAPP_CORE_PLUGIN	"mgappcore.so"
#define DEFAULT_CONFIG_FILE   	"/etc/mgapp.config"
#define DEFAULT_MAIN_FUNC       "mgappMain"
#define MAX_LINE_LEN 		1024	

typedef void (*SimpleVoidFunc) (void);
typedef int  (*SimpleIntFunc) (void);
typedef void *(*MainFunc) (void*);

struct plugin_def {
    char *path_name;
    char *plugin_name;
    void *handle;
    int usage_cnt;
    char api_unload_allow;
    main_args_t main_args;
    MainFunc myMainFunc;
    pthread_t thread_id;
};

#ifdef BUILD_STATIC

struct pluginfunc_table {
        int (*plugin_func)(void);
	char name[128];
};

#endif

/* XXX I really want these 3 defs in mgapp_main but I can't get it to work! */
/* if I can get this to work but can't determine a begin/end, could do an 
*  init in the core plugin and add a marker for each init func

#define __pinit __attribute_used__ __attribute__((__section__(".init.plugin_init")))
#define __pluginit_table(fn) \
	struct pluginit_table __pluginit_table_##fn __pinit = { fn }
*/


#endif
