--[[

        This script is to play audio preview from audio input port 0/1/

--]]

-----------------------------------------------------------------------
--                     Configuration parameters                      --
-----------------------------------------------------------------------
INCH =       2;

SAMPLERATE = SAMPLERATE or 48000;
SAMPLESIZE = SAMPLESIZE or 16;

---------------------------------------------------------------------
-- Don't change below this line unless you know what you are doing --
---------------------------------------------------------------------

sysctl0:configure({param=Q_SYS_CFG_PLL3_CLOCK_HZ, value=12288000});
sysctl0:configure({param=Q_SYS_CFG_AUD0_CLOCK_HZ, value=12288000});
sysctl0:configure({param=Q_SYS_CFG_AUD1_CLOCK_HZ, value=12288000});

board.setAudioSampleFreq({port=0, freq=SAMPLERATE});

avoc0 = sysctl0:avocCreate({name="avoc0"});

sain = {};
avsn = {};
ach = {};

INCH = INCH - 1;

for i = 0, INCH do
    sain[i] = sysctl0:sainCreate({name="sain", port=i});
    avsn[i] = sysctl0:avsnCreate({name="avsn"});

    --sain[i]:setParam({param=Q_SAIN_CMP_AUD_CHANNEL_NUM, value=Q_SAIN_CHANNEL_STEREO});
    sain[i]:setParam({param=Q_SAIN_CMP_AUD_SERIAL_MODE, value=Q_SAIN_CFP_AUD_SERIAL_MODE_I2S});
    sain[i]:setParam({param=Q_SAIN_CMP_AUD_MASTER_CLOCK, value=Q_SAIN_CFP_AUD_MASTER_CLOCK_256FS});
    sain[i]:setParam({param=Q_SAIN_CMP_AUD_SAMPLE_RATE, value=SAMPLERATE});
    sain[i]:setParam({param=Q_SAIN_CMP_AUD_SAMPLE_SIZE, value=SAMPLESIZE});
    sain[i]:activateCfg();

    avsn[i]:bindAudioInput({src=sain[i]});
    ach[i] = avoc0:addAudioChannel({channel=Q_AVOC_CFP_AUD_STEREO});
end

--avoc0:setAudioChannelSource({ch=ach[0], src=avsn[0]});
--avoc0:enableAudioChannel({ch=ach[0], enable=1});
avoc0:setAudioChannelSource({ch=ach[1], src=avsn[1]});
avoc0:enableAudioChannel({ch=ach[1], enable=1});

avoc0:setParam({param=Q_AVOC_CMP_AUD_SERIAL_MODE, value=Q_AVOC_CFP_AUD_SERIAL_MODE_I2S});
avoc0:setParam({param=Q_AVOC_CMP_AUD_MASTER_CLOCK, value=Q_AVOC_CFP_AUD_MASTER_CLOCK_256FS});
avoc0:setParam({param=Q_AVOC_CMP_AUD_SAMPLE_RATE, value=SAMPLERATE});
avoc0:setParam({param=Q_AVOC_CMP_AUD_SAMPLE_SIZE, value=SAMPLESIZE});
avoc0:activateCfg();

avoc0:activateAudioChannelCfg();

avoc0:start();
for i = 0, INCH do
    avsn[i]:start();
    sain[i]:start();
end

